/*  Classe Processeur
* Elle contient le centre nerveux du LittleThinker..
* C'est la frame qui affiche le processeur, et qui instancie une mémoire...
* Elle contient aussi le moteur d'analyse syntaxique du pseudo langage...
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;



public class Processeur extends JFrame implements ActionListener,Runnable {
	Registres lesRegistres;
	RegistresControle controle;
	Memoire laMemoire;
	JLabel informations;
	String commande; //la commande en cours pour que tout le monde y acccède..
	Thread runner; //pour l'animation...
	
	public Processeur() {
		//dans le constructeur, j'ajoute simplement mes objets...
		super("Le Processeur");
		setSize(560,220);
		Container g1=getContentPane();
		//JPanel g=new LeFond();
		JPanel g=new JPanel();
		g1.add(g);
		g.setLayout(new BorderLayout());
		JPanel logos=new JPanel();//un panel pour le titre et l'aide
			informations=new JLabel("<html><HR> - <B>LittleThinker"
				+" V 0.11</b> - <HR>");
			logos.add(informations);
		g.add(logos,BorderLayout.NORTH);
		lesRegistres= new Registres();
		g.add(lesRegistres,BorderLayout.WEST);
		JPanel boutons=new JPanel(); //et un autre pour les boutons
			boutons.setLayout(new BorderLayout());
			JButton go=new JButton("<html><B><FONT COLOR=GREEN>Go !");
			go.addActionListener(this);
			JButton aide=new JButton("Infos...");
			aide.addActionListener(this);
			JButton pasAPas=new JButton("Next");
			pasAPas.addActionListener(this);
			boutons.add(go,BorderLayout.CENTER);
			boutons.add(aide,BorderLayout.WEST);
			boutons.add(pasAPas,BorderLayout.EAST);
		g.add(boutons,BorderLayout.SOUTH);
		controle=new RegistresControle();
		g.add(controle,BorderLayout.EAST);
		//pack();
		setVisible(true);
		//et j'instancie une mémoire (afin de pouvoir l'adresser !)
		laMemoire=new Memoire();
		//runner=new Thread(this);
		
	}
	public void actionPerformed(ActionEvent e) {
		// c'est l'écouteur sur les boutons..
		if(e.getActionCommand().equals("Infos...")) {
			//Ecran A propos de...
			JOptionPane.showMessageDialog(this,
				"LittleThinker Version 0.11\nSous licence "+
				"GNU General Public Licence.\n\nPetit "+
				"simulateur de microprocesseur très basic, "+
				"qui permet de\nvisualiser le fonctionnement"+
				" théorique d'un micro-processeur.\n\n\n"+
				"Auteur : Sylvain Cherrier Jan 2003.\n\n\n"+
				"Convention d'écriture : On préfixe par\n"+
				"# pour un registre,\na pour l'accumulateur,\n"+
				"$ pour une case mémoire,\nrien pour une"+
				" valeur.\n\nNOTA : On peut utiliser l'accès"+
				" mémoire indirect avec $# (aller à\n"+
				"l'adresse indiquée dans le registre).\n\n"+
				"Commandes implémentées :"+
				"\nld-st-mv\nadd-sub-mul-div-mod-dec-inc-cmp\n"+
				"bne-beq-bde-bnd-bmi-bpl-brn.\n\n\nPour plus "+
				"d'infos, voir http://sylvain.cherrier.free.fr",
				"LittleThinker",
				JOptionPane.INFORMATION_MESSAGE);

		} else if(e.getActionCommand().equals("Next")) {
			if(!instructionSuivante()) {
				//je suis au bout.. Je dois repartir à zero
				lesRegistres.raz();	//on nettoie tout !
				controle.raz();
				controle.setCO(0);
			}
		} else {
			//c'est le bouton GO !!!
			int compteur=0;
	
			lesRegistres.raz();	//on nettoie tout !
			controle.raz();
			controle.setCO(compteur); //j'initialise au premier pas
			do {    //la boucle qui décode, décode, décode...
				// afin de déboguer, je log sur l'écran texte tout ce
				// que je fais...
				repaint();
				System.out.print("execution n°"+(compteur++)+" -> ");
			} while (instructionSuivante());
		}
	}

	public boolean instructionSuivante() {	
		/*cette méthode renvoit vrai si il y a une instruction
		* suivante... Elle lance tout les traitements
		*/

		//je récupère la commande
		commande=laMemoire.getCase(controle.getCO());
		System.out.println(commande);	
		// si c'est une commande, on la traite, sinon on
		// previent la méthode appelante que c'est fini ! 	
		if(commande==null || commande.equals("")) {
			controle.transfert("STOP");
			return(false);
		} else {
			controle.transfert(commande);
			//run();//lancement du raisonnement et de l'animation
			runner=new Thread(this);
			runner.start();
			try {
				runner.join();
			} catch(InterruptedException e) {
				System.out.println("aie!!");
			} 
			
			return(true);
		}
	}

	public synchronized void  run() {//synchronisé, sinon, c'est la cata !!
		boolean rupture=false; //au cas ou il y a un jump !!
		//je commence par découper la commande en un tableau
		// de String
		String[] laCde=new String[3];
		StringTokenizer st=new StringTokenizer(commande," ");
		int i=0;
		while(st.hasMoreTokens()) {
			laCde[i++]=st.nextToken();
		}
			
		/*c'est parti pour le décodage...
		* petite particularité, je cherche d'abord
		* A) les instructions qui dépendent du registre d'état...
		* B) je nettoye le registre d'état ensuite...
		* C) Puis je recherche les autres types d'instructions...*/

		if(laCde[0].equalsIgnoreCase("bnz")) {
			//si pas Z, alors on saute à l'adresse indiquée
			if(!controle.isZ()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}
		} else if(laCde[0].equalsIgnoreCase("beq")) {
			//si Z, alors on saute à l'adresse indiquée
			if(controle.isZ()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}
		} else if(laCde[0].equalsIgnoreCase("bmi")) {
			//si inférieur à 0 (N), alors on saute...
			if(controle.isN()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}
		} else if(laCde[0].equalsIgnoreCase("bpl")) {
			//si supérieur à 0 (pas N), alors on saute...
			if(!controle.isN()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}
		} else if(laCde[0].equalsIgnoreCase("bde")) {
			//si on a des chiffres après la virgule, alors on saute...
			if(controle.isD()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}
		} else if(laCde[0].equalsIgnoreCase("bnd")) {
			//si pas de chiffres après la virgule, alors on saute...
			if(!controle.isD()) {
				rupture=true;
				controle.setCO(Integer.parseInt(laCde[1]));
			}

		} else if(laCde[0].equalsIgnoreCase("brn")) {
			//on saute inconditionnellement
			rupture=true;
			controle.setCO(Integer.parseInt(laCde[1]));
		}



		controle.clearEtats();//nettoyage du registre d'état !! (B)
		//puis test des autres instructions...(C)
		if(laCde[0].equalsIgnoreCase("ld")) {
			// c'est un chargement...
			int lavaleur;
			//gestion de l'arg 2, soit une valeur, soit une adresse
			if(laCde[2].charAt(0)=='$')
				lavaleur=litCase(laCde[2]);
			else try {			
				lavaleur=Integer.parseInt(laCde[2]);
			} catch(NumberFormatException nfe) {
				System.out.println("Erreur de syntaxe !");
				lavaleur=0; //je plante l'argument
			}

			//maintenant, determinons la cible...
			switch(laCde[1].charAt(0)) {
				case 'a'://dans l'accu...
				case 'A'://dans l'accu
					controle.setA(alerte(lavaleur));
					break;
				case '#'://dans un registre
					int reg=Integer.parseInt(laCde[1].substring(1));
					lesRegistres.load(reg,alerte(lavaleur));
					break;
			}
		} else if(laCde[0].equalsIgnoreCase("st")) {
			//c'est un rangement en mémoire
			int valeur=0; //valeur à ranger
			switch(laCde[1].charAt(0)) {
			//test de l'origine
				case 'a'://de l'accu
				case 'A':
					valeur=controle.getA();
					break;
				case '#': //d'un registre
					int reg=Integer.parseInt(laCde[1].substring(1));
					valeur=lesRegistres.getRegistre(reg);
					break;
				default :
					valeur=Integer.parseInt(laCde[1]);
			}
			//et enfin, on ecrit à l'adresse laCde[2]
			ecritCase(laCde[2],valeur);

		} else if(laCde[0].equalsIgnoreCase("mv")) {
			//on déplace... entre registres et/ou accumulateur
			int valeur=0; //valeur à ranger
			switch(laCde[1].charAt(0)) {
			//test de l'origine
				case 'a'://de l'accu
				case 'A':
					valeur=controle.getA();
					break;
				case '#': //d'un registre
					int reg=Integer.parseInt(laCde[1].substring(1));
					valeur=lesRegistres.getRegistre(reg);
					break;
				default :
					valeur=Integer.parseInt(laCde[1]);
			}
			//maintenant, determinons la cible...
			switch(laCde[2].charAt(0)) {
				case 'a'://dans l'accu...
				case 'A'://dans l'accu
					controle.setA(alerte(valeur));
					break;
				case '#'://dans un registre
					int reg=Integer.parseInt(laCde[2].substring(1));
					lesRegistres.load(reg,alerte(valeur));
					break;
			}
			
		} else if(laCde[0].equalsIgnoreCase("inc")) {
			//on incremente... uniquement les registres...
			int leReg=Integer.parseInt(laCde[1].substring(1));
			int val=lesRegistres.getRegistre(leReg);
			lesRegistres.load(leReg,alerte(val+1));

		} else if(laCde[0].equalsIgnoreCase("dec")) {
			//on incremente... uniquement les registres...
			int leReg=Integer.parseInt(laCde[1].substring(1));
			int val=lesRegistres.getRegistre(leReg);
			lesRegistres.load(leReg,alerte(val-1));
		
		} else if(!laCde[0].substring(0,1).equalsIgnoreCase("b")) {
			/* c'est une opération arithmétique (add,sub,mul,div,mod,cmp) !!
			* car ce n'est pas une opération de branchement (goret, vous
			* avez dit goret ??? :-)
			* Je capitalise ici le traitement des arguments,
			* puis j'effectue l'opération sur l'accumulateur...
			*/
			//Je definis d'abord les valeurs en jeu...
			int val;
                  float resultat=0;

			switch(laCde[1].charAt(0)) {
				case '#'://c'est un registre
					int reg=Integer.parseInt(laCde[1].substring(1));
					val=lesRegistres.getRegistre(reg);
					break;
				case '$'://c'est une adresse mémoire
					val=litCase(laCde[1]);
					break;
		
				default :// soit une valeur
					val=Integer.parseInt(laCde[1]);
			}
			
			//Je teste maintenant l'opération, et j'agis en conséquence..
			if(laCde[0].equalsIgnoreCase("add")) 
				resultat=controle.getA()+val;
			else if(laCde[0].equalsIgnoreCase("sub")) 
				resultat=controle.getA()-val;
			else if(laCde[0].equalsIgnoreCase("mul")) 
				resultat=controle.getA()*val;
			else if(laCde[0].equalsIgnoreCase("div")) 
				resultat=(float)controle.getA()/(float)val;
			else if(laCde[0].equalsIgnoreCase("mod")) 
                                resultat=controle.getA()%val;
			
			if(laCde[0].equalsIgnoreCase("cmp"))
				alerte(controle.getA()-val);//compare l'accu à la valeur
			else
                        	controle.setA(alerte(resultat));//je mets à jour l'accumulateur...
		} 
		
			

		if(!rupture) //si on passe à la commande suivante 
			controle.setCO(controle.getCO()+1);//donc +1 dans le co
	}	

	public int alerte(float valeur) {	
		/*méthode qu'on appellera, et qui renverra la valeur qu'on lui
		* a passé.. Cependant, déclenche si nécessaire les modifs dans 
		* le registre d'état...
		*/ 
		if(valeur<0)
			controle.setEtat(" N ");
		else if(valeur==0)
			controle.setEtat(" Z ");
                if(Math.floor(valeur)!=valeur)
                        controle.setEtat(" D ");
		return((int)valeur);
	}	

        public int alerte(int valeur) {
		//surcharge
                return alerte((float)valeur);
	}

	public int adresseMem(String argument) {
		/* cette methode se charge de récuperer l'adresse mémoire
		* demandée.. L'intéret est de centraliser ici les accès
		* possibles... (indexé $#2 par exemple...)
	      */

		int leResultat;

		String adresse=argument.substring(1);//on récupere après $

		if(adresse.charAt(0)=='#') {// c'est le contenu d'un registre
			int indiceReg=Integer.parseInt(adresse.substring(1));
			//on va cherche le contenu pointé par le registre
			leResultat=lesRegistres.getRegistre(indiceReg);
		} else {
			//c'est simplement la case pointée
			leResultat=Integer.parseInt(adresse);
		}
		
		return(leResultat);
	}

	public int litCase(String argument) {
		//méthode d'accès à la mémoire
		String valeur=laMemoire.getCase(adresseMem(argument));
		return(Integer.parseInt(valeur));
	}


	public void ecritCase(String argument,int valeur) {
		//méthode d'écirture en mémoire
		laMemoire.setCase(adresseMem(argument),valeur);
	}

}
